package com.mh.common.http;

/**
 * HTTP结果封装
 * @author Louis
 * @date Jan 12, 2019
 */
public class HttpResult {

	private int code = 200; // 为成功
	private String msg;     // 消息
	private Object data;    // 数据对象
	private int count;      // 记录数

	public static HttpResult error() {

		return error(HttpStatus.SC_INTERNAL_SERVER_ERROR, "未知异常，请联系管理员");
	}

	public static HttpResult error(String msg)
	{
		return error(HttpStatus.SC_INTERNAL_SERVER_ERROR, msg);
	}

	public static HttpResult error(int code, String msg) {
		HttpResult r = new HttpResult();
		r.setCode(code);
		r.setMsg(msg);
		return r;
	}

	public static HttpResult ok(String msg) {
		HttpResult r = new HttpResult();
		r.setMsg(msg);
		return r;
	}

	public static HttpResult ok(Object data) {
		HttpResult r = new HttpResult();
		r.setData(data);
		return r;
	}

	public static HttpResult ok(String msg, Object data) {
		HttpResult r = new HttpResult();
		r.setMsg(msg);
		r.setData(data);
		return r;
	}

	public static HttpResult ok(int count, Object data) {
		HttpResult r = new HttpResult();
		r.setCount(count);
		r.setData(data);
		return r;
	}

	public static HttpResult ok() {
		HttpResult r = new HttpResult();
		r.setMsg("success");
		r.setCode(200);
		return r;
	}

	public int getCode() {
		return code;
	}

	public void setCode(int code) {
		this.code = code;
	}

	public String getMsg() {
		return msg;
	}

	public void setMsg(String msg) {
		this.msg = msg;
	}

	public Object getData() {
		return data;
	}

	public void setData(Object data) {
		this.data = data;
	}

	public int getCount() {
		return count;
	}

	public void setCount(int count) {
		this.count = count;
	}
}
