package com.mh.user.config;

import com.alibaba.fastjson2.JSON;
import com.alibaba.fastjson2.JSONObject;
import com.mh.user.dynamic.datasource.DataSourceContextHolder;
import com.mh.user.dynamic.datasource.DataSourceObject;
import com.mh.user.entity.DBEntity;
import com.mh.user.service.SysUserService;
import com.mh.user.utils.JwtTokenUtils;
import com.mh.user.utils.AESUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.web.servlet.HandlerInterceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author chison
 * @date 2020-09-03 08:44
 * @Description 请求拦截器
 */
@Component
public class PrimessionInterceptor implements HandlerInterceptor  {


    @Autowired
    private SysUserService sysUserService;

    /**
     * 根据token获取用户项目信息，对数据源进行切换
     * @param request
     * @param response
     * @param handler
     * @return
     * @throws Exception
     */
    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        String token = request.getHeader("token");
        if (token != null && token.contains("token")) {
            JSONObject jsonObject = (JSONObject) JSON.parse(token);
            System.out.println("header---->" + jsonObject.get("token"));
            if (jsonObject.get("token") !=null ) {
                token = jsonObject.get("token").toString();
            }
            System.out.println(" token==> " + token);
        }
        String uri = request.getRequestURI();
        System.out.println(uri);
        DataSourceContextHolder.setDBType("default");
        // 除了中间库业务的请求都使用多数据源切换
//        if(!(uri.contains("/sysUser") || uri.contains("/sysRole") || uri.contains("/sysMenu") )){
//            if(token != null){
//                String userName = JwtTokenUtils.getUsernameFromToken(token);
//                System.out.println(userName);
//                DBEntity dbEntity = sysUserService.queryDBInfo(userName);
//                dbEntity.setDB_Pwd(AESUtil.AESdecrypt(dbEntity.getDB_Pwd()));
//                // 切换数据源
//                DataSourceObject dataSourceObject = new DataSourceObject();
//                String SourceName = "sqlServer-"+dbEntity.getDB_Names();
//                dataSourceObject.SwitchSQLServerDataSource(dbEntity,SourceName);
//                DataSourceContextHolder.setDBType(SourceName);
//            }
//        }
        return true;
    }
}
