package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.entity.AnalysisMonthEntity;
import com.mh.user.entity.AnalysisYearEntity;
import com.mh.user.service.AnalysisService;
import com.mh.user.service.BuildingService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("analysis")
public class AnalysisController {

    @Autowired
    AnalysisService analysisService;

    @Autowired
    BuildingService buildingService;

    @PostMapping("/queryYear") //type=1（水），2（电），3（能耗），4（维保）
    public HttpResult queryAnalysisYear(@RequestParam(value = "curDate",required = true) String curDate,
                                    @RequestParam(value = "buildingId",required = true) String buildingId,
                                    @RequestParam(value = "type",defaultValue = "3") int type) {
      try{
          List<AnalysisYearEntity> list;
          list=analysisService.queryAnalysisYear(curDate,buildingId,type);
          return HttpResult.ok(list);
      }catch (Exception e){
          e.printStackTrace();
          return HttpResult.error();
      }

    }

    @PostMapping("/queryMonth") //type=1（水），2（电），3（能耗）
    public HttpResult queryAnalysisMonth(@RequestParam(value = "curDate",required = true) String curDate,
                                        @RequestParam(value = "buildingId",required = true) String buildingId,
                                        @RequestParam(value = "type",defaultValue = "3") int type) {
        try{
            List<AnalysisMonthEntity> list;
            list=analysisService.queryAnalysisMonth(curDate,buildingId,type);
            return HttpResult.ok(list);
        }catch (Exception e){
            e.printStackTrace();
            return HttpResult.error();
        }
    }
}
