package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.annotation.SysLogger;
import com.mh.user.entity.ControlSetEntity;
import com.mh.user.entity.PumpSetEntity;
import com.mh.user.service.ControlSetService;
import com.mh.user.service.PumpSetService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

@RestController
@RequestMapping("controller")
public class ControlSetController {

    @Autowired
    ControlSetService controlSetService;

    @Autowired
    PumpSetService pumpSetService;

    //保存控制设置值
    @SysLogger(title="控制设置",optDesc = "保存控制设置值")
    @PostMapping(value="/save")
    public HttpResult saveControlSet(@RequestBody ControlSetEntity controlSetEntity) {
        try{
            controlSetService.saveControlSet(controlSetEntity);
            return HttpResult.ok("保存成功！");
        }catch (Exception e){
            e.printStackTrace();
            return HttpResult.error();
        }
    }

    //保存热泵设置值
    @SysLogger(title="控制设置",optDesc = "保存热泵设置值")
    @PostMapping(value="/pumpSave")
    public HttpResult saveControlSet(@RequestBody PumpSetEntity pumpSetEntity) {
        try{
            pumpSetService.savePumpSet(pumpSetEntity);
            return HttpResult.ok("保存成功！");
        }catch (Exception e){
            e.printStackTrace();
            return HttpResult.error();
        }
    }

    //查询设置表
    @SysLogger(title="控制设置",optDesc = "查询设置值")
    @PostMapping(value="/query")
    public HttpResult queryControlSet(@RequestParam("buildingId") String buildingId) {
        try{
            ControlSetEntity control=controlSetService.queryControlSet(buildingId);
            return HttpResult.ok(control);
        }catch (Exception e){
//            e.printStackTrace();
            return HttpResult.error();
        }
    }
}
