package com.mh.user.controller;


import com.mh.common.http.HttpResult;
import com.mh.user.annotation.SysLogger;
import com.mh.user.entity.BuildingEntity;
import com.mh.user.entity.DataResultEntity;
import com.mh.user.service.BuildingService;
import com.mh.user.service.DataResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.ArrayList;
import java.util.List;

@RestController
@RequestMapping("dataResult")
public class DataResultController {

    @Autowired
    DataResultService dataResultService;

    @Autowired
    BuildingService buildingService;

    @SysLogger(title="用能查询",optDesc = "查询抄表读数")
    @PostMapping(value="/query")
    public HttpResult queryDataResult(@RequestParam(value = "buildingId", required = false) String buildingId,
                                      @RequestParam(value= "startDate", required=false)String startDate,
                                      @RequestParam(value= "endDate", required=false)String endDate,
                                      @RequestParam(value= "deviceType", required=false)String deviceType,
                                      @RequestParam(value= "page", required=true)Integer page,
                                      @RequestParam(value= "limit", required=true)Integer limit) {

        try{

           int count=dataResultService.getDataResultCount(buildingId,startDate,endDate,deviceType,page,limit);
           List<DataResultEntity> records=dataResultService.queryDataResult(buildingId,startDate,endDate,deviceType,page,limit);
           return HttpResult.ok(count,records);
        }catch (Exception e){
//            e.printStackTrace();
            return HttpResult.error();
        }

    }
}
