package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.entity.GatewayManageEntity;
import com.mh.user.service.impl.DeviceDisplayServiceImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

@RestController
@RequestMapping("gateway")
public class GatewayManageController {

    @Autowired
    private DeviceDisplayServiceImpl.GatewayManageService gatewayManageService;

    //保存
    @PostMapping(value="/save")
    public HttpResult addOrUpdateGateWayInfo(@RequestBody GatewayManageEntity gatewayManageEntity) {
//        try{
//            gatewayManageService.addOrUpdateGateWayInfo(gatewayManageEntity);
//            return HttpResult.ok();
//        }catch (Exception e){
//            return HttpResult.error();
//        }

        gatewayManageService.addOrUpdateGateWayInfo(gatewayManageEntity);
        return HttpResult.ok();
    }

    // 按条件查询
    @PostMapping(value="/query")
    public HttpResult queryAll( @RequestParam(value = "gatewayID", required = false)String gatewayID,
                                   @RequestParam(value = "operator", required = false)String operator,
                                   @RequestParam(value = "grade", required = false)String grade,
                                   @RequestParam(value= "page", required=true)Integer page,
                                   @RequestParam(value= "limit", required=true)Integer limit) {
        try{
            int count=gatewayManageService.queryCount(gatewayID,operator,grade);
            List<GatewayManageEntity> records=gatewayManageService.queryAll(gatewayID,operator, grade,page,limit);
            return HttpResult.ok(count,records);
        }catch (Exception e){
            e.printStackTrace();
            return HttpResult.error();
        }

    }

    // 删除
    @PostMapping(value="/delete")
    public HttpResult deleteGatewayManageByID( @RequestParam(value = "gatewayID")String gatewayID){
        try{
            gatewayManageService.deleteGatewayManageByID(Integer.parseInt(gatewayID));
            return HttpResult.ok();
        }catch (Exception e){
            e.printStackTrace();
            return HttpResult.error();
        }
    }

}
