package com.mh.user.controller;

import com.mh.common.http.HttpResult;
import com.mh.user.annotation.BusinessType;
import com.mh.user.annotation.SysLogger;
import com.mh.user.entity.NowDataEntity;
import com.mh.user.entity.NowPublicDataEntity;
import com.mh.user.model.TempModel;
import com.mh.user.service.BuildingService;
import com.mh.user.service.NowDataService;
import com.mh.user.service.NowPublicDataService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@RestController
@RequestMapping("monitor_public")
public class NowPublicDataController {

    @Autowired
    NowPublicDataService nowPublicDataService;

    @Autowired
    BuildingService buildingService;

    @Autowired
    NowDataService nowDataService;

    @PostMapping("/queryNow")
    public HttpResult queryNowData(@RequestParam(value = "buildingId") String buildingId){
        try{
            NowPublicDataEntity nowPublicDataEntity=nowPublicDataService.queryNowPublicData(buildingId);
            return  HttpResult.ok(nowPublicDataEntity);
        }catch (Exception e){
            //e.printStackTrace();
            return  HttpResult.error("查询公共信息出错!");
        }
    }

    @PostMapping("/query")
    public HttpResult queryHistoryData(@RequestParam(value = "curDate") String curDate,
                                       @RequestParam(value = "buildingId") String buildingId,
                                       @RequestParam(value = "page") int page,
                                       @RequestParam(value = "limit") int limit){
        try{
            List<NowPublicDataEntity> list=new ArrayList<NowPublicDataEntity>();
            list=nowPublicDataService.queryHistoryPublicData(curDate,buildingId,page,limit);
            int count=nowPublicDataService.getHistoryPublicDataCount(curDate,buildingId,page,limit);
            return  HttpResult.ok(count,list);
        }catch (Exception e){
            //e.printStackTrace();
            return  HttpResult.error("查询出错!");
        }
    }

    @PostMapping("/temp")
    public HttpResult buildWaterTemp(@RequestParam(value = "buildingName",required = false) String buildingName){
        try{
            if (buildingName!=null && !buildingName.equals("")){
                String buildingId=buildingService.selectBuildingId(buildingName);
                TempModel tempModel=nowPublicDataService.queryWtTemp2(buildingId);
                return  HttpResult.ok(1,tempModel);
            }else{
                List<TempModel> list=nowPublicDataService.queryWtTemp();  //楼栋所有水箱平均温度
                int count=list.size();
                return  HttpResult.ok(count,list);
            }
        }catch (Exception e){
//            e.printStackTrace();
            return  HttpResult.error(500,"查询楼栋水温异常!");
        }
    }

//    @PostMapping("/temp")
//    public HttpResult buildWaterTemp2(@RequestParam(value = "buildingName") String buildingName){
//        try{
//            String buildingId=buildingService.selectBuildingId(buildingName);
//            TempModel tempModel=nowPublicDataService.queryWtTemp2(buildingId);
//            return  HttpResult.ok("success",tempModel);
//        }catch (Exception e){
////            e.printStackTrace();
//            return  HttpResult.error(500,"查询楼栋水温异常!");
//        }
//    }
}
