package com.mh.user.dynamic.datasource;

import com.alibaba.druid.pool.DruidDataSource;
import com.mh.user.entity.DBEntity;

import java.util.HashMap;
import java.util.Map;

/**
 * @author chison
 * @date 2020-04-02 09:40
 * @Description
 */
public class DataSourceObject {

    private Long MaxWait=6000L;
    private Integer maxActive=10;
    private Long timeBetweenEvictionRunsMillis=6000L;

    /**
     * 切换sqlserver数据库，并动态赋值
     * @param dbInfo
     * @param SourceName
     */
    public void SwitchMySQLDataSource(DBEntity dbInfo, String SourceName) {
        System.out.println("mysql进入数据源切换");
        System.out.println("MaxWait:"+MaxWait);
        DruidDataSource dynamicDataSource = new DruidDataSource();
        dynamicDataSource.setDriverClassName("com.mysql.cj.jdbc.Driver");
        dynamicDataSource.setUrl("jdbc:mysql://"+dbInfo.getDB_IP()+":"+dbInfo.getDB_Port()+"/"+dbInfo.getDB_Names()+"?serverTimezone=UTC&useUnicode=true&characterEncoding=UTF-8&useJDBCCompliantTimezoneShift=true&autoReconnect=true");
        dynamicDataSource.setUsername(dbInfo.getDB_UserName());
        dynamicDataSource.setPassword(dbInfo.getDB_Pwd());
        dynamicDataSource.setMaxWait(MaxWait);
        dynamicDataSource.setMaxActive(maxActive);
        dynamicDataSource.setTimeBetweenEvictionRunsMillis(timeBetweenEvictionRunsMillis);

        DynamicDataSource dataSource = DynamicDataSource.getInstance();
        Map<Object, Object> map=new HashMap<Object, Object>();
        map.put(SourceName, dynamicDataSource);
        dataSource.setTargetDataSources(map);
        System.out.println(dynamicDataSource.getUrl());
        System.out.println(SourceName);
    }
    /**
     * 第二个sqlserver数据库
     * @param dbInfo
     * @param SourceName
     */
    public void SwitchSQLServerDataSource(DBEntity dbInfo,String SourceName) {
        System.out.println("进入数据源切换");
        System.out.println("MaxWait:"+MaxWait);
        DruidDataSource dynamicDataSource = new DruidDataSource();
        dynamicDataSource.setDriverClassName("com.microsoft.sqlserver.jdbc.SQLServerDriver");
        dynamicDataSource.setUrl("jdbc:sqlserver://"+dbInfo.getDB_IP()+":"+dbInfo.getDB_Port()+";Databasename="+dbInfo.getDB_Names());
        dynamicDataSource.setUsername(dbInfo.getDB_UserName());
        dynamicDataSource.setPassword(dbInfo.getDB_Pwd());
        System.out.println(dbInfo.getDB_UserName());
        System.out.println(dbInfo.getDB_Pwd());
        dynamicDataSource.setMaxWait(MaxWait);
        dynamicDataSource.setMaxActive(maxActive);
        dynamicDataSource.setTimeBetweenEvictionRunsMillis(timeBetweenEvictionRunsMillis);

        DynamicDataSource dataSource = DynamicDataSource.getInstance();
        Map<Object, Object> map=new HashMap<Object, Object>();
        map.put(SourceName, dynamicDataSource);
        dataSource.setTargetDataSources(map);

        System.out.println(dynamicDataSource.getUrl());
        System.out.println(SourceName);
    }
}
