package com.mh.user.exception;

public class ServiceRuntimeException extends RuntimeException{
    /**
     * 错误码
     */
    private int code;
    /**
     * 错误信息
     */
    private String message;

    public ServiceRuntimeException(String message){
        super(message);
        this.message = message;

    }

    public ServiceRuntimeException(int code,String message){
        super(message);
        this.code = code;
        this.message = message;

    }

    //Throwable是Error和Exception的父类，用来定义所有可以作为异常被抛出来的类。
    public ServiceRuntimeException(int code,String message,Throwable cause){
        super(message,cause);
        this.code = code;
        this.message = message;

    }

    public ServiceRuntimeException(BaseErrorInfo baseErrorInfo){
        super(baseErrorInfo.getResultMsg());
        this.code = baseErrorInfo.getResultCode();
        this.message = baseErrorInfo.getResultMsg();
    }

    public ServiceRuntimeException(BaseErrorInfo baseErrorInfo, Throwable cause){
        super(baseErrorInfo.getResultMsg(),cause);
        this.code = baseErrorInfo.getResultCode();
        this.message = baseErrorInfo.getResultMsg();
    }


    public int getCode() {
        return code;
    }

    public void setCode(int code) {
        this.code = code;
    }

    @Override
    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }
}

