package com.mh.user.mapper;

import com.mh.user.entity.ControlSetEntity;
import com.mh.user.entity.PumpSetEntity;
import org.apache.ibatis.annotations.*;

@Mapper
public interface ControlSetMapper {

    //插入记录
    @Insert("insert into control_set(building_id,level_set,use_start_time1,use_close_time1,use_start_time2,use_close_time2," +
            "back_water_temp,up_water_temp,use_start_time3,use_close_time3,use_start_time4,use_close_time4,use_start_time5,use_close_time5,use_start_time6,use_close_time6) values (" +
            "#{buildingId},#{levelSet},#{useStartTime1},#{useCloseTime1},#{useStartTime2},#{useCloseTime2},#{backWaterTemp},#{upWaterTemp},#{useStartTime3},#{useCloseTime3}," +
            "#{useStartTime4},#{useCloseTime4},#{useStartTime5},#{useCloseTime5},#{useStartTime6},#{useCloseTime6})")
    void saveControlSet(ControlSetEntity controlSetEntity);

    //修改记录
    @Update("<script>" +
            "  update control_set set  " +
            "  <if test='buildingId!=null'>  building_id = #{buildingId} </if>" +
            "  <if test='levelSet!=null'> , level_set = #{levelSet} </if>" +
            "  <if test='useStartTime1!=null'> , use_start_time1 = #{useStartTime1} </if>" +
            "  <if test='useCloseTime1!=null'> , use_close_time1 = #{useCloseTime1} </if>" +
            "  <if test='useStartTime2!=null'> , use_start_time2 = #{useStartTime2} </if>" +
            "  <if test='useCloseTime2!=null'> , use_close_time2 = #{useCloseTime2} </if>" +
            "  <if test='useStartTime3!=null'> , use_start_time3 = #{useStartTime3} </if>" +
            "  <if test='useCloseTime3!=null'> , use_close_time3 = #{useCloseTime3} </if>" +
            "  <if test='useStartTime4!=null'> , use_start_time4 = #{useStartTime4} </if>" +
            "  <if test='useCloseTime4!=null'> , use_close_time4 = #{useCloseTime4} </if>" +
            "  <if test='useStartTime5!=null'> , use_start_time5 = #{useStartTime5} </if>" +
            "  <if test='useCloseTime5!=null'> , use_close_time5 = #{useCloseTime5} </if>" +
            "  <if test='useStartTime6!=null'> , use_start_time6 = #{useStartTime6} </if>" +
            "  <if test='useCloseTime6!=null'> , use_close_time6 = #{useCloseTime6} </if>" +
            "  <if test='backWaterTemp!=null'> , back_water_temp = #{backWaterTemp} </if>" +
            "  <if test='upWaterTemp!=null'> , up_water_temp = #{upWaterTemp} </if>" +
            "   where building_id = #{buildingId}" +
            "</script>")
    void updateControlSet(ControlSetEntity controlSetEntity);

    //查询记录数
    @Select("select count(*) from control_set  where  building_id=#{buildingId}")
    int selectCount(@Param("buildingId") String buildingId);

    //查询记录
    @Results({
            @Result(column = "building_id",property = "buildingId" ),
            @Result(column = "level_set", property = "levelSet"),
            @Result(column = "use_start_time1", property = "useStartTime1"),
            @Result(column = "use_close_time1", property = "useCloseTime1"),
            @Result(column = "use_start_time2", property = "useStartTime2"),
            @Result(column = "use_close_time2", property = "useCloseTime2"),
            @Result(column = "use_start_time3", property = "useStartTime3"),
            @Result(column = "use_close_time3", property = "useCloseTime3"),
            @Result(column = "use_start_time4", property = "useStartTime4"),
            @Result(column = "use_close_time4", property = "useCloseTime4"),
            @Result(column = "use_start_time5", property = "useStartTime5"),
            @Result(column = "use_close_time5", property = "useCloseTime5"),
            @Result(column = "use_start_time6", property = "useStartTime6"),
            @Result(column = "use_close_time6", property = "useCloseTime6"),
            @Result(column = "back_water_temp", property = "backWaterTemp"),
            @Result(column = "up_water_temp", property = "upWaterTemp"),
    })
    @Select("select * from control_Set where building_id=#{buildingId}")
    ControlSetEntity queryControlSet(@Param("buildingId") String buildingId);
}
