package com.mh.user.mapper.provider;

public class DeviceInstallProvider {

    public String queryDevice(String buildingId,String deviceType,String startDate,String endDate,String isOnline,String isUse,String isFault, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select * from (" +
                " select top 1000 *,ROW_NUMBER() over(order by T.sort) as rn  from (select top 1000 t1.*,t2.sort from device_install t1  " +
                " join building t2 on t1.building_id=t2.id  where 1=1 ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND t1.building_id = #{buildingId} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND t1.device_type = #{deviceType} ");
        }
        if (startDate != null && endDate != null) {
            sql.append(" AND CONVERT(varchar(10),t1.install_date,121)>=#{startDate} and CONVERT(varchar(10),t1.install_date,121)<=#{endDate} ");
        }
        else if (isOnline != null && !isOnline.equals("")){
            sql.append(" AND t1.is_online = #{isOnline} ");
        }
        if (isUse != null && !isUse.equals("")){
            sql.append(" AND t1.is_use = #{isUse} ");
        }
        if (isFault != null && !isFault.equals("")){
            sql.append(" AND t1.is_fault = #{isFault} ");
        }
        if ((page != 0) && (limit != 0)){
                sql.append("  order by t2.sort ) T )TT  where TT.rn>(#{page}-1)*#{limit} and TT.rn<=#{page}*#{limit}");
        } else if (page == 0){
                sql.append("  order by t2.sort ) T )TT ");
        }
//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String getCount(String buildingId,String deviceType,String startDate,String endDate,String isOnline,String isUse,String isFault, int page, int limit){
        StringBuffer sql = new StringBuffer("");
        sql.append("select count(*) from (" +
                " select top 1000 *,ROW_NUMBER() over(order by T.sort) as rn  from (select top 1000 t1.*,t2.sort from device_install t1   " +
                " join building t2 on t1.building_id=t2.id  where 1=1  ");
        if (buildingId != null && !buildingId.equals("")){
            sql.append(" AND t1.building_id = #{buildingId} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND t1.device_type = #{deviceType} ");
        }
        if (startDate != null && endDate != null) {
            sql.append(" AND CONVERT(varchar(10),t1.install_date,121)>=#{startDate} and CONVERT(varchar(10),t1.install_date,121)<=#{endDate} ");
        }
        else if (isOnline != null && !isOnline.equals("")){
            sql.append(" AND t1.is_online = #{isOnline} ");
        }
        if (isUse != null && !isUse.equals("")){
            sql.append(" AND t1.is_use = #{isUse} ");
        }
        if (isFault != null && !isFault.equals("")){
            sql.append(" AND t1.is_fault = #{isFault} ");
        }
        sql.append(" order by t2.sort ) T )TT ");
//        System.out.println(sql.toString());
        return sql.toString();
    }

    //查询设备故障数
    public String getIsFaultCount(String isFault,String deviceType){
        StringBuffer sql = new StringBuffer("");

        sql.append("select count(*) from device_install " +
                " where 1=1 ");
        if (isFault != null && !isFault.equals("")){
            sql.append(" AND is_fault = #{isFault} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }

//        System.out.println(sql.toString());
        return sql.toString();
    }

    public String getIsOnlineCount(String isOnline,String deviceType){
        StringBuffer sql = new StringBuffer("");

        sql.append("select count(*) from device_install " +
                " where 1=1 ");
        if (isOnline != null && !isOnline.equals("")){
            sql.append(" AND is_online = #{isOnline} ");
        }
        if (deviceType != null && !deviceType.equals("")){
            sql.append(" AND device_type = #{deviceType} ");
        }

//        System.out.println(sql.toString());
        return sql.toString();
    }
}
