package com.mh.user.primary;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * @author ljf
 * @title ：
 * @description ： 使用原生的socket
 * @updateTime 2020-05-20
 * @throws ：
 */
public class Clients {

    Socket socketServer;
    ExecutorService executorService;

    public Clients() throws IOException {
        socketServer = new Socket("192.168.1.222", 10001);
        // 创建新的线程池
        executorService = Executors.newCachedThreadPool();
        executorService.execute(new ClientThread(socketServer));
    }

    class ClientThread extends Thread{
        Socket socket;
        BufferedReader in;
        PrintWriter out;
        InputStreamReader keybox = new InputStreamReader(System.in);
        BufferedReader br = new BufferedReader(keybox);
        public ClientThread(Socket socket) throws IOException {
            this.socket = socket;
            /**用于读取客户端返回的信息**/
            in = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            out = new PrintWriter(socket.getOutputStream());
        }
        @Override
        public void run() {
            try {
                while(true){
                    String str = br.readLine();
                    out.println(str);
                    out.flush();
                    System.out.println("服务器响应"+in.readLine());
                    if(str.equals("bye")){
                        break;
                    }
                }
                in.close();
                out.close();
                socket.close();
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }

        }
    }

    public static void main(String[] args) throws IOException {
        new Clients();
    }

}

