package com.mh.user.service;

import com.mh.user.entity.AlarmInfoEntity;
import com.mh.user.entity.AlarmValueSetEntity;
import org.apache.ibatis.annotations.*;

import java.util.List;

public interface AlarmInfoService {


    /**
     * 报警管理
     * 保存报警信息
     * @param alarmInfoEntity
     */
    void saveAlarmInfo(AlarmInfoEntity alarmInfoEntity);

    /**
     * 报警管理
     * 根据日期修改报警信息
     * @param alarmInfoEntity
     */
    void updateAlarmInfo(AlarmInfoEntity alarmInfoEntity);

    /**
     * 报警管理
     * 根据日期、设备、楼栋查询报警信息
     * @param alarmTime
     * @param alarmType
     * @param buildingId
     * @param page
     * @param limit
     * @return
     */

    List<AlarmInfoEntity> queryAlarmInfo(String alarmTime,String alarmType,
                                         String buildingId,String dealState,int page,int limit);


    /**
     * 报警管理
     * 根据日期、设备类型查询记录数
     * @return
     */
    int getAlarmInfoCount(String alarmTime,String alarmType,
                          String buildingId,String dealState,int page,int limit);

    /**
     * 报警管理
     * 根据报警编号删除报警信息
     * @param id
     */
    void deleteAlarmInfo(String id);

    //警报设置
    void saveAlarmValueSet(AlarmValueSetEntity alarmValueSetEntity);

    //修改处理状态
    void updateDealState(String id,String dealState);

    //查询报警值设置记录
    List<AlarmValueSetEntity> queryAlarmValueSet(String buildingId,String itemType,int page,int limit);

    //查询报警值设置记录数
    int getAlarmValueSetCount(String buildingId,String itemType);

    //删除设置记录
    void delAlarmValueSet(String id);

    //按楼栋编号删除设置记录
    void delAlarmValueSet2(String buildingId,String itemType);

}
