package com.mh.user.service;

import com.mh.user.entity.*;
import com.mh.user.mapper.provider.DeviceFloorProvider;
import com.mh.user.model.DeviceModel;
import com.mh.user.model.PumpModel;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.SelectProvider;

import java.util.List;

public interface DeviceFloorService {

    /**
     * 设备管理模块
     * 保存设备信息
     * @param deviceFloorEntity
     */
    int saveDevice(DeviceFloorEntity deviceFloorEntity);

    /**
     * 设备管理模块
     * 保存设备信息
     * @param deviceFloorEntity
     */
    int updateDevice(DeviceFloorEntity deviceFloorEntity);

    /**
     * 设备管理模块：
     * 查询设备资料
     * @param buildingId
     * @param deviceType
     * @param page
     * @param limit
     * @return
     */
    List<DeviceFloorEntity> queryDeviceFloor(String buildingId, String deviceType,int page, int limit);

    /**
     * 楼面设备模块
     * 获取设备查询的总条数
     * @param buildingId
     * @param deviceType
     * @param page
     * @param limit
     * @return
     */
    int getCount(String buildingId,String deviceType,int page,int limit);

    //查询所有水箱名称
    List<DeviceModel> selectDeviceName(String buildingId, String deviceType);

    //根据楼栋、类型、设备名称判断是否存在
    int selectDeviceCount(String buildingId,String deviceType,String deviceName);

    DeviceModel selectTankName(String buildingId, String deviceType,String pumpId);

    //查询水箱编号
    String selectDeviceId(String deviceName,String deviceType,String buildingId);

    //查询非远程控制普通热泵
    PumpModel selectDeviceId2(String deviceType,String buildingId);
    /**
     * 设备管理模块：
     * 根据通讯地址删除设备信息
     * @param records
     */
    int deleteDevice(List<DeviceFloorEntity> records);

    /**
     * 设备管理模块：
     * 根据设备编号删除设备信息
     * @param id
     */
    int deleteDevice(String id);

    // Excel导入相关函数
    // 删除临时表
    void deleteDevice_floor_temp();

    // 插入临时表
    void insertDevice_floor_temp(UploadDeviceFloorEntity uploadDeviceFloorEntity);

    // 查询Excel导入的数据
    List<DeviceFloorTempEntity> queryExcelDevices();

    // 查询Excel导入的数据的记录数
    int queryExcelDevicesCount();

    // 在导入中的数据有重复
    void updateDevice_floor_temp__multiple();

}
