package com.mh.user.service;

import com.mh.user.entity.EnergyEntity;
import com.mh.user.model.SumModel;
import java.util.List;

public interface EnergyService {

    /**
     * 生产信息
     * 保存
     * @param energyEntity
     */
    void saveEnergy(EnergyEntity energyEntity,int type);

    /**
     * 生产信息
     * 修改
     * @param energyEntity
     */
    void updateEnergy(EnergyEntity energyEntity,int type);

    /**
     * 生产信息
     * 根据时间日期和楼栋编号删除记录
     * @param curDate
     * @param buildingId
     */
    void deleteEnergy(String curDate,String buildingId,int type);


    /**
     * 生产信息
     * 查询
     * @param buildingId
     * @param startDate
     * @param endDate
     * @param page
     * @param limit
     * @param type （1按天，2按月，3按年）
     * @return
     */
    List<EnergyEntity> queryEnergy(String buildingId, String startDate,String endDate,
                                       int page, int limit,int type);

    /**
     * 生产信息
     * 查询记录数
     * @return
     */
    int getEnergyCount( String buildingId, String startDate,String endDate,
                           int page, int limit,int type);

    /**
     * 生产信息
     * 查询
     * @param curDate
     * @param type (1按天，2按月，3按年)
     * @return
     */
    List<EnergyEntity> queryEnergyGroup(String curDate, int type);

    //查询每天的用量
    List<EnergyEntity> queryDayEnergy(String buildingId, String startDate, String endDate, int page, int limit);

    int getDayEnergyCount(String buildingId, String startDate, String endDate, int page, int limit);

    //查询小时的用量
    List<EnergyEntity> queryHourEnergy(String buildingId,String curDate, int page, int limit);

    int getHourEnergyCount(String buildingId, String curDate);

    //查询记录
    List<EnergyEntity> queryEnergyBuilding(int page,int limit);

    //查询记录数
    int getEnergyBuildingCount();

    void proEnergyBuilding(String curDate,String endDate,int type);

    SumModel queryEnergySum();

}
