package com.mh.user.service;

import com.mh.user.entity.MaintainInfoEntity;

import java.util.List;

public interface MaintainInfoService {

    /**
     * 维修保养模块
     * 维修保养信息
     * @param maintainInfoEntity
     */
    int saveMaintainInfo(MaintainInfoEntity maintainInfoEntity);

    /**
     * 维修保养模块
     * 根据日期修改维修保养信息
     * @param maintainInfoEntity
     */
    int updateMaintainInfo(MaintainInfoEntity maintainInfoEntity);

    /**
     * 维修保养模块
     * 根据日期、设备类型查询维修保养信息
     * @param curDate
     * @param deviceType
     * @param page
     * @param limit
     * @return
     */
    List<MaintainInfoEntity> queryMaintainInfo(String curDate,String buildingId,String deviceType, int page, int limit);

    /**
     * 维修保养模块
     * 根据日期、设备类型查询记录数
     * @return
     */
    int getMaintainInfoCount(String curDate,String buildingId, String deviceType, int page, int limit);


    /**
     * 维修保养模块
     * 根据维护编号删除维修保养信息
     * @param id
     */
    void deleteMaintainInfo(String id);
}
