package com.mh.user.service;

import com.mh.common.annotation.SysLogger;
import com.mh.user.entity.NowDataEntity;
import com.mh.user.entity.PumpMinutesEntity;
import com.mh.user.entity.WaterLevelEntity;
import com.mh.user.entity.WaterTempEntity;
import com.mh.user.model.WaterLevelModel;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Select;

import java.util.List;

public interface NowDataService {

    //保存监控界面实时信息
    void saveNowData(NowDataEntity nowDataEntity);

    //保存热泵相关数据
    void saveNowHistoryData(String pumpId,String deviceType,String strData,String dataType,String buildingId);

    //非热泵保存数据
    void saveNowHistoryData2(String deviceAddr,String deviceType,String strData,String dataType,String buildingId);

    //非热泵温度变送器相关数据
    void saveNowHistoryData3(String pumpId,String deviceType,String strData,String dataType,String buildingId);

    //修改监控界面实时信息
    void updateNowData(NowDataEntity nowDataEntity);

    //查询监控界面实时信息
    List<NowDataEntity> queryNowData(String buildingId);

    //按热泵查询当前状态
    NowDataEntity queryNowDataByPump(String buildingId,String pumpId);

    //保存监控界面历史信息
    void saveHistoryData(NowDataEntity nowDataEntity);

    //修改监控界面历史信息
    void updateHistoryData(NowDataEntity nowDataEntity);

    //查询监控界面历史信息
    List<NowDataEntity> queryHistoryData(String curDate,String buildingId,String pumpId,String tankId,int page,int limit);

    //查询记录数
    int getHistoryDataCount(String curDate,String buildingId,String pumpId,String tankId,int page,int limit);

    //查询水位
    List<WaterLevelEntity> queryWaterLevel(String curDate, String buildingID, int page, int limit);

    //查询水位记录数
    int getWaterLevelCount(String curDate,String buildingID);

    //按时间查询水位
    List<WaterLevelModel> queryWaterLevelByTime(String curDate,int page,int limit);

    //按时间查询水位记录
    int waterLevelByTimeCount(String curDate);

    //查询每天楼栋水位变化
    List<WaterLevelEntity> queryBuildWaterLevel(String curDate, int page, int limit);

    //查询每天楼栋水位变化记录数
    int buildWaterLevelCount(String curDate);

    //从监视表查询热泵温度平均值
    String selectAve(String buildingId);

    //求单个热泵温度
    String selectSingleTemp(String pumpId,String buildingId);

    //从监视表查询热泵运行状态
    String selectStateCount(String buildingId);

    //从监视表查询热泵运行状态
    String selectState(String buildingId,String pumpId);

    //更新设置水位值
    void upLevelSet(String buildingId,String levelSet);

    //更新设置温度值
    void upTempSet(String buildingId,String tempSet);

    //更新设置温度值
    void upTempSet2(String buildingId,String tempSet,String pumpID);

    //查询每天24小时每个热泵温度变化情况
    @SysLogger
    List<WaterTempEntity> queryWaterTemp(String buildingID,String curDate,int page,int limit);

    int queryWaterTempCount(String buildingID,String curDate);

    //查询每天24小时每个热泵温度变化情况2
    List<WaterTempEntity> queryWaterTemp2(String curDate,int page,int limit);

    int queryWaterTempCount2(String curDate);

    //生成楼栋温度
    void proWaterTemp(String curDate,String buildingID,String pumpID);

    //生成楼栋水位
    void proWaterLevel(String curDate,String buildingID, String deviceAddr);

    //在没有接收到返回值前设置监控界面热泵是否离线
    void updateRunState(String buildingId,String pumpId,String strState, String buildingName);

    //计算热泵运行时间,按分钟
    void proPumpMinutes(String buildingId,String pumpId,String runState);

    //按日查询运行时长
    List<PumpMinutesEntity> pumpMinutes(String startDate,String endDate,String buildingId,String pumpId,int page,int limit);

    int pumpMinutesCount(String startDate,
                         String endDate,
                         String buildingId,
                         String pumpId);

    //按周查询运行时长
    List<PumpMinutesEntity> pumpWeekMinutes(String startDate,String endDate,String buildingId,String pumpId,int page,int limit);

    int pumpWeekMinutesCount(String startDate,
                         String endDate,
                         String buildingId,
                         String pumpId);

    //按月查询运行时长
    List<PumpMinutesEntity> pumpMonthMinutes(String startDate,String endDate,String buildingId,String pumpId,int page,int limit);

    int pumpMonthMinutesCount(String startDate,
                             String endDate,
                             String buildingId,
                             String pumpId);

    //通过楼栋编号获取最小热泵id号,规定最小热泵号为单箱
    String selectMinPumpId(String buildingId);

}

