package com.mh.user.service;


import com.mh.common.service.CurdService;
import com.mh.user.model.SysMenu;
import com.mh.user.model.SysRole;
import com.mh.user.model.SysRoleMenu;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;

import java.util.List;

/**
 * 角色管理
 * @author Louis
 * @date Oct 29, 2018
 */
public interface SysRoleService extends CurdService<SysRole> {

	/**
	 * 查询全部
	 * @return
	 */
	List<SysRole> findAll();

	/**
	 * 查询角色菜单集合
	 * @return
	 */
	List<SysMenu> findRoleMenus(Long roleId);

	/**
	 * 保存角色菜单
	 * @param records
	 * @return
	 */
	int saveRoleMenus(List<SysRoleMenu> records);

	/**
	 * 根据名称查询
	 * @param name
	 * @return
	 */

	List<SysRole> findByName(String name);

	//根据名称查找编号
	SysRole findId(String name);

	//查询所有角色
	List<SysRole> queryRoles(String roleName, int page,int limit);

	//查询所有记录数
	int getCount( String roleName,int page,int limit);

}
