package com.mh.user.service;

import com.mh.common.service.CurdService;
import com.mh.user.entity.DBEntity;
import com.mh.user.model.SysUser;
import com.mh.user.model.SysUserRole;
import org.apache.ibatis.annotations.Param;


import java.util.List;
import java.util.Set;


/**
 * 用户管理
 * @author Louis
 * @date Oct 29, 2018
 */
public interface SysUserService extends CurdService<SysUser> {

	DBEntity queryDBInfo(String username);


	SysUser findByName(String userName);

	/**
	 * 查找用户的菜单权限标识集合
	 * @param userName
	 * @return
	 */
	Set<String> findPermissions(String userName);

	/**
	 * 查找用户的角色集合
	 * @param userId
	 * @return
	 */
	List<SysUserRole> findUserRoles(Long userId);

	//查询用户
	List<SysUser> queryUsers(String userName,int page,int limit);

	//查询记录数
	int getCount(String userName,int page,int limit);

	//根据id修改操作员密码
	void updatePassword(String password,String salt,String id);

	//根据操作员名称修改登录日期
	void updateLoginTime(String userName);
}
