package com.mh.user.service.impl;

import com.mh.user.entity.AlarmInfoEntity;
import com.mh.user.entity.AlarmValueSetEntity;
import com.mh.user.mapper.AlarmInfoMapper;
import com.mh.user.service.AlarmInfoService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class AlarmInfoServiceImpl implements AlarmInfoService {

    @Autowired
    AlarmInfoMapper alarmInfoMapper;

    @Override
    public void saveAlarmInfo(AlarmInfoEntity alarmInfoEntity) {
        alarmInfoMapper.saveAlarmInfo(alarmInfoEntity);
    }

    @Override
    public void updateAlarmInfo(AlarmInfoEntity alarmInfoEntity) {
        alarmInfoMapper.updateAlarmInfo(alarmInfoEntity);
    }

    @Override
    public List<AlarmInfoEntity> queryAlarmInfo(String alarmTime, String alarmType, String buildingId,String dealState, int page, int limit) {
        return alarmInfoMapper.queryAlarmInfo(alarmTime, alarmType, buildingId,dealState, page, limit);
    }

    @Override
    public int getAlarmInfoCount(String alarmTime, String alarmType, String buildingId,String dealState, int page, int limit) {
        return alarmInfoMapper.getAlarmInfoCount(alarmTime, alarmType, buildingId,dealState, page, limit);
    }

    @Override
    public void deleteAlarmInfo(String id) {
        alarmInfoMapper.deleteAlarmInfo(id);
    }

    @Override
    public void saveAlarmValueSet(AlarmValueSetEntity alarmValueSetEntity) {
        try{
//            alarmInfoMapper.delAlarmValueSet(); //先删除
            alarmInfoMapper.saveAlarmValueSet(alarmValueSetEntity);//后保存

        }catch (Exception e){
           e.printStackTrace();
        }
    }

    @Override
    public void updateDealState(String id, String dealState) {
        alarmInfoMapper.updateDealState(id,dealState);
    }


    @Override
    public List<AlarmValueSetEntity> queryAlarmValueSet(String buildingId,String itemType, int page, int limit) {
        return alarmInfoMapper.queryAlarmValueSet(buildingId,itemType,page,limit);
    }

    @Override
    public int getAlarmValueSetCount(String buildingId,String itemType) {
        return alarmInfoMapper.getAlarmValueSetCount(buildingId,itemType);
    }

    @Override
    public void delAlarmValueSet(String id) {
        alarmInfoMapper.delAlarmValueSet(id);
    }

    @Override
    public void delAlarmValueSet2(String buildingId,String itemType) {
        alarmInfoMapper.delAlarmValueSet2(buildingId,itemType);
    }
}
