package com.mh.user.service.impl;

import com.mh.user.entity.*;
import com.mh.user.mapper.DeviceFloorMapper;
import com.mh.user.model.DeviceModel;
import com.mh.user.model.PumpModel;
import com.mh.user.service.DeviceFloorService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.Date;
import java.util.List;

@Service
public class DeviceFloorServiceImpl implements DeviceFloorService {

    @Autowired
    private DeviceFloorMapper deviceFloorMapper;

    @Override
    public int saveDevice(DeviceFloorEntity deviceFloorEntity) {
        return deviceFloorMapper.saveDevice(deviceFloorEntity);
    }

    @Override
    public int updateDevice(DeviceFloorEntity deviceFloorEntity) {
        return deviceFloorMapper.updateDevice(deviceFloorEntity);
    }

    @Override
    public List<DeviceFloorEntity> queryDeviceFloor(String buildingId,String deviceType,int page, int limit) {
        return deviceFloorMapper.queryDeviceFloor(buildingId,deviceType,page,limit);
    }

    @Override
    public int getCount(String buildingId, String deviceType, int page, int limit) {
        return deviceFloorMapper.getCount(buildingId,deviceType,page,limit);
    }

    @Override
    public List<DeviceModel> selectDeviceName(String buildingId, String deviceType) {
        return deviceFloorMapper.selectDeviceName(buildingId,deviceType);
    }

    @Override
    public int selectDeviceCount(String buildingId, String deviceType, String deviceName) {
        return deviceFloorMapper.selectDeviceCount(buildingId,deviceType,deviceName);
    }

    @Override
    public DeviceModel selectTankName(String buildingId, String deviceType, String pumpId) {
        return deviceFloorMapper.selectTankName(buildingId,deviceType,pumpId);
    }

    @Override
    public String selectDeviceId(String deviceName, String deviceType,String buildingId) {
        return deviceFloorMapper.selectDeviceId(deviceName,deviceType,buildingId);
    }

    @Override
    public PumpModel selectDeviceId2(String deviceType, String buildingId) {
        return deviceFloorMapper.selectDeviceId2(deviceType,buildingId);
    }

    @Override
    public int deleteDevice(List<DeviceFloorEntity> records) {
        for(DeviceFloorEntity record:records) {
            deviceFloorMapper.deleteDevice(record.getId().toString());
        }
        return 0;
    }

    @Override
    public int deleteDevice(String id) {
        return deviceFloorMapper.deleteDevice(id);
    }

    //Excel导入相关处理函数
    @Override
    public void deleteDevice_floor_temp() {
        deviceFloorMapper.deleteDevice_floor_temp();
    }

    @Override
    public void insertDevice_floor_temp(UploadDeviceFloorEntity uploadDeviceFloorEntity) {
        String deviceName   = uploadDeviceFloorEntity.getDeviceName();
        String deviceType  = uploadDeviceFloorEntity.getDeviceType();
        String buildingId    = uploadDeviceFloorEntity.getBuildingId();
        String model=uploadDeviceFloorEntity.getModel();
        String specs=uploadDeviceFloorEntity.getSpecs();
        String rowId         = uploadDeviceFloorEntity.getRowId();
        deviceFloorMapper.insertDevice_floor_temp(deviceName, deviceType, buildingId, model, specs, rowId);
    }

    // 查询Excel导入的数据
    @Override
    public List<DeviceFloorTempEntity> queryExcelDevices(){
        return deviceFloorMapper.queryExcelDevices();
    };

    // 查询Excel导入的数据的记录数
    @Override
    public int queryExcelDevicesCount(){
        return deviceFloorMapper.queryExcelDevicesCount();
    };

    // 在导入中的数据有重复
    @Override
    public void updateDevice_floor_temp__multiple() {
        deviceFloorMapper.updateDevice_floor_temp__multiple();
    }

    /**
     * @author nxr
     * @title ：
     * @description ：判断导入资料数据的合法性
     * @updateTime 2022-06-19
     * @throws ：
     */
    public void updateDevice_floor_temp(){
        //判断通讯地址，在导入中的数据有重复
        deviceFloorMapper.updateDevice_floor_temp__multiple();
    }

}
