package com.mh.user.service.impl;

import com.mh.user.entity.DeviceManageEntity;
import com.mh.user.mapper.DeviceManageMapper;
import com.mh.user.service.DeviceManageService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-05-14
 * @throws ：
 */
@Slf4j
@Component
@Service
public class DeviceManageServiceImpl implements DeviceManageService {

    // 构造方法注入
    private final DeviceManageMapper deviceManageMapper;

    @Autowired
    public DeviceManageServiceImpl(DeviceManageMapper deviceManageMapper) {
        this.deviceManageMapper = deviceManageMapper;
    }

    @Override
    public List<DeviceManageEntity> getDeviceByOther(String deviceNum) {
        return deviceManageMapper.getDeviceByOther(deviceNum);
    }

    @Override
    public void addOrUpdateBaseMeter(DeviceManageEntity deviceManageEntity) {
        if(deviceManageEntity.getType().equals("edit")){
            deviceManageMapper.updateBaseMeter(deviceManageEntity);
        }else if(deviceManageEntity.getType().equals("add")){
            deviceManageMapper.insertBaseMeter(deviceManageEntity);
        }
    }

    /**
     * 删除设备信息
     * @param deviceId
     * @param deviceType
     */
    @Override
    public void deleteDeviceInfo(Integer deviceId, String deviceType) {
        deviceManageMapper.deleteDeviceInfo(deviceId,deviceType);
    }

    @Override
    public List<DeviceManageEntity> queryDevicesByType(String  deviceType) {
        return deviceManageMapper.queryDevicesByType(deviceType);
    }

    @Override
    public List<DeviceManageEntity> queryAllDevice() {
        log.info("查询全部设备------------------");
        return deviceManageMapper.queryAllDevice();
    }

    @Override
    public List<DeviceManageEntity> queryDeviceByOther(int page, int size, String deviceNum) {
        return deviceManageMapper.queryDeviceByOther(page, size, deviceNum);
    }

    @Override
    public int queryDeviceByOtherCount(String deviceNum) {
        return deviceManageMapper.queryDeviceByOtherCount(deviceNum);
    }
}
