package com.mh.user.service.impl;

import com.mh.user.entity.EnergyEntity;
import com.mh.user.mapper.EnergyMapper;
import com.mh.user.model.SumModel;
import com.mh.user.service.EnergyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

@Service
public class EnergyServiceImpl implements EnergyService {

    @Autowired
    EnergyMapper energyMapper;

    @Override
    public void saveEnergy(EnergyEntity energyEntity,int type) {

        if(type==1){                            // 保存天
            energyMapper.saveEnergyDay(energyEntity);
        }else if(type==2){                      // 保存月
            energyMapper.saveEnergyMonth(energyEntity);
        }else if(type==3){                      // 保存年
            energyMapper.saveEnergyYear(energyEntity);
        }
    }

    @Override
    public void updateEnergy(EnergyEntity energyEntity,int type) {

        if(type==1){
            energyMapper.updateEnergyDay(energyEntity);
        } else if (type==2){
            energyMapper.updateEnergyMonth(energyEntity);
        } else if (type==3){
            energyMapper.updateEnergyYear(energyEntity);
        }
    }

    @Override
    public void deleteEnergy(String curDate, String buildingId,int type) {

        if(type==1){
            energyMapper.deleteEnergyDay(curDate,buildingId);
        } else if (type==2){
            energyMapper.deleteEnergyMonth(curDate,buildingId);
        } else if (type==3){
            energyMapper.deleteEnergyYear(curDate,buildingId);
        }
    }

    @Override
    public List<EnergyEntity> queryEnergy(String buildingId, String startDate,String endDate, int page, int limit,int type) {
        List<EnergyEntity> list=new ArrayList<EnergyEntity>();
        if(type==1) {
            list=energyMapper.queryEnergyDay(buildingId,startDate,endDate,page,limit);
        } else if (type==2){
            list=energyMapper.queryEnergyMonth(buildingId,startDate,endDate,page,limit);
            System.out.println(list);
        } else if (type==3){
            list=energyMapper.queryEnergyYear(buildingId,startDate,endDate,page,limit);
        }
        return list;
    }

    @Override
    public int getEnergyCount(String buildingId, String startDate,String endDate, int page, int limit,int type) {
        int r=0; // 记录数
        if(type==1) {
            r=energyMapper.getEnergyDayCount(buildingId,startDate,endDate, page, limit);
        }else if (type==2){
            r=energyMapper.getEnergyMonthCount(buildingId,startDate,endDate, page, limit);
        } else if (type==3){
            r=energyMapper.getEnergyYearCount(buildingId,startDate,endDate, page, limit);
        }
        return r;
    }

    @Override
    public List<EnergyEntity> queryEnergyGroup(String curDate, int type) {
        if(type==2) {
            return energyMapper.queryEnergyMonthGroup(curDate);
        }else if (type==3){
            return energyMapper.queryEnergyYearGroup(curDate);
        }else {
            return energyMapper.queryEnergyDayGroup(curDate);
        }
    }

    @Override
    public List<EnergyEntity> queryDayEnergy(String buildingId, String startDate, String endDate, int page, int limit) {
        return energyMapper.queryDayEnergy(buildingId,startDate,endDate,page,limit);
    }

    @Override
    public int getDayEnergyCount(String buildingId, String startDate, String endDate, int page, int limit) {
        return energyMapper.getDayEnergyCount(buildingId,startDate,endDate,page,limit);
    }

    @Override
    public List<EnergyEntity> queryHourEnergy(String buildingId, String curDate, int page, int limit) {
        return energyMapper.queryHourEnergy(buildingId,curDate,page,limit);
    }

    @Override
    public int getHourEnergyCount(String buildingId, String curDate) {
        return energyMapper.getHourEnergyCount(buildingId,curDate);
    }

    @Override
    public List<EnergyEntity> queryEnergyBuilding(int page, int limit) {
        return energyMapper.queryEnergyBuilding(page,limit);
    }

    @Override
    public int getEnergyBuildingCount() {
        return energyMapper.getEnergyBuildingCount();
    }

    @Override
    public void proEnergyBuilding(String curDate, String endDate, int type) {
        energyMapper.proEnergyBuilding(curDate,endDate,type);
    }

    @Override
    public SumModel queryEnergySum() {
        return energyMapper.queryEnergySum();
    }
}
