package com.mh.user.service.impl;

import com.mh.common.page.ColumnFilter;
import com.mh.common.page.MybatisPageHelper;
import com.mh.common.page.PageRequest;
import com.mh.common.page.PageResult;
import com.mh.user.entity.SysParamEntity;
import com.mh.user.mapper.SysLogMapper;
import com.mh.user.model.SysLog;
import com.mh.user.service.SysLogService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

@Service
public class SysLogServiceImpl  implements SysLogService {

	@Autowired
	private SysLogMapper sysLogMapper;

	@Override
	public synchronized int save(SysLog record) {
		if(record.getId() == null || record.getId() == 0) {
			return sysLogMapper.insertSelective(record);
		}
		return sysLogMapper.updateByPrimaryKeySelective(record);
	}

	@Override
	public int delete(SysLog record) {
		return sysLogMapper.deleteByPrimaryKey(record.getId());
	}

	@Override
	public int delete(List<SysLog> records) {
		for(SysLog record:records) {
			delete(record);
		}
		return 1;
	}

	@Override
	public SysLog findById(Long id) {
		return sysLogMapper.selectByPrimaryKey(id);
	}

	@Override
	public PageResult findPage(PageRequest pageRequest) {
		ColumnFilter columnFilter = pageRequest.getColumnFilter("userName");
		if(columnFilter != null) {
			return MybatisPageHelper.findPage(pageRequest, sysLogMapper, "findPageByUserName", columnFilter.getValue());
		}
		return MybatisPageHelper.findPage(pageRequest, sysLogMapper);
	}

	@Override
	public List<SysLog> findLogs(String userName, int page, int limit) {
		return sysLogMapper.findLogs(userName,page,limit);
	}

	@Override
	public int findCount(String userName, int page, int limit) {
		return sysLogMapper.findCount(userName,page,limit);
	}

	@Override
	public SysLog logInfo(int id) {
		return sysLogMapper.logInfo(id);
	}

	@Override
	public SysParamEntity selectSysParam() {
		return sysLogMapper.selectSysParam();
	}
}
