package com.mh.user.device;

import com.mh.user.dto.DeviceMessageDTO;
import com.mh.user.dto.DisplayBoxDataDTO;
import com.mh.user.entity.ChillersEntity;
import com.mh.user.entity.DeviceManageEntity;
import com.mh.user.mapper.DeviceManageMapper;
import com.mh.user.service.DeviceDisplayService;
import com.mh.user.service.DeviceManageService;
import com.mh.user.utils.AnalysisReceiveOrder485;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.test.context.SpringBootTest;

import java.util.List;

/**
 * @author ljf
 * @title ：
 * @description ：
 * @updateTime 2020-05-15
 * @throws ：
 */
@Slf4j
@SpringBootTest
public class DeviceTest {

    @Autowired
    DeviceManageService deviceManageService;

    @Autowired
    DeviceDisplayService deviceDisplayService;

    // 查询设备详情数据
    @Test
    public void queryDeviceDisplay() {
        List<DisplayBoxDataDTO> displayBoxDataDTOList = deviceDisplayService.deviceDisplayBoxData("host",String.valueOf(0));
        for (DisplayBoxDataDTO displayBoxDataDTO :
                displayBoxDataDTOList) {
            log.info(displayBoxDataDTO.toString());
        }
    }

    // 查询设备状态
    @Test
    public void queryDeviceState() {
        List<DeviceMessageDTO> deviceMessageList = deviceDisplayService.queryDeviceStatus("host");
        for (DeviceMessageDTO deviceMessage:
            deviceMessageList){
            log.info(deviceMessage.toString());
        }
    }


    @Test
    public void queryDeviceByOthers() {
        List<DeviceManageEntity> deviceManageEntityList = deviceManageService.queryDeviceByOther(1,10, "88");
        for (DeviceManageEntity deviceManage :
                deviceManageEntityList) {
            log.info(deviceManage.toString());
        }
//        for (int i = 0; i < deviceManageEntityList.size(); i++) {
//            if (deviceManageEntityList.get(i).getDeviceType().equalsIgnoreCase("1")) {      // 1 代表广仪电表
//                // 生成电表指令
//                String meterOrderStr = GetReadOrder485.createMeterOrder("169.254.194.199","8080","2",deviceManageEntityList.get(i).getCollectionNum(),"1");
//                log.info("电表指令------" + meterOrderStr);
//            } else if (deviceManageEntityList.get(i).getDeviceType().equalsIgnoreCase("3")) {      // 3 代表冷量计
//                // 生成电表指令
//                String meterOrderStr = GetReadOrder485.createCloudOrder(deviceManageEntityList.get(i).getCollectionNum(),"34");
//                log.info("冷量计指令------" + meterOrderStr);
//            }
//        }
        int count = deviceManageService.queryDeviceByOtherCount("88");
        log.info("总数： " + count);
    }


    @Autowired
    DeviceManageMapper deviceManageMapper;

    @Test
    public void queryByTest() {
        List<DeviceManageEntity> deviceManageEntityList = deviceManageMapper.queryDevicesByType1("manage");
        for (DeviceManageEntity deviceManage :
                deviceManageEntityList) {
            log.info(deviceManage.toString());
        }
    }

}
