package com.mh.user.socket;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

/**
 * @author ljf
 * @title ：
 * @description ： 阻塞式编程
 * @updateTime 2020-04-20
 * @throws ：
 */
public class BIOServer {

    // 引用线程池
    private static ExecutorService threadPool = Executors.newCachedThreadPool();

    public static void main(String[] args) throws Exception {
        ServerSocket sc = new ServerSocket(9093);
        System.out.println("服务器启动成功！");
        while (!sc.isClosed()) {
            Socket request = sc.accept(); // 阻塞
            System.out.println("收到新连接:" + request.toString());

            // 引用线程池
            threadPool.execute(() -> {
                try {
                    InputStream is = request.getInputStream(); // net+i/o
                    BufferedReader reader = new BufferedReader(new InputStreamReader(is, "utf-8"));
                    String msg;
                    while ((msg = reader.readLine()) != null) { // 没有数据会阻塞
                        if (msg.length() == 0) {
                            break;
                        }
                        System.out.println(msg);
                    }
                    System.out.println("收到数据，来自：" + request.toString());

                    // 响应http结果
                    // 响应结果
                    OutputStream outputStream = request.getOutputStream();
                    outputStream.write("HTTP/1.1 200 ok\r\n".getBytes());
                    outputStream.write("Content-Length: 40\r\n\r\n".getBytes());
                    outputStream.write("<button type=\\\"button\\\">Click Me!</button>".getBytes());
                } catch (Exception e) {
                    // TODO: handle exception
                } finally {
                    try {
                        request.close();
                    } catch (Exception e2) {
                        // TODO: handle exception
                    }
                }
            });

//            try {
//                InputStream is = request.getInputStream(); // net+i/o
//                BufferedReader reader = new BufferedReader(new InputStreamReader(is, "utf-8"));
//                String msg;
//                while ((msg = reader.readLine()) != null) { // 没有数据会阻塞
//                    if (msg.length() == 0) {
//                        break;
//                    }
//                    System.out.println(msg);
//                }
//                System.out.println("收到数据，来自：" + request.toString());
//            } catch (Exception e) {
//                // TODO: handle exception
//            } finally {
//                try {
//                    request.close();
//                } catch (Exception e2) {
//                    // TODO: handle exception
//                }
//            }

        }
    }

}
